---
slug: 3-aptana-eclipse-et-xulrunner
title: Aptana Studio/Eclipse et Xulrunner
categories: [Outils]
tags: 
- Aptana Studio
- Eclipse
- Xulrunner
date: "2011-12-16T00:00:00+01:00"
summary: >
  Comment résoudre l'erreur "Unhandled event loop exception" dans Aptana Studio
  et Eclipse 3.7 avec Xulrunner
---

Depuis quelques mois, j'ai une erreur gênante dans Aptana Studio et Eclipse 3.7
(les paquets autonomes, pas ceux des dépôts) chaque fois que j'ai essayé de
faire une action git ou hg.

J'ai pu vivre avec jusqu'à maintenant, mais aujourd'hui, cela me dérangeait
vraiment.

L'erreur est :

{{< highlight text >}}
Unhandled event loop exception
No more handles [Unknown Mozilla path (MOZILLA_FIVE_HOME not set)]
{{< /highlight >}}

Le fichier log montrait la trace suivante :

{{< highlight text >}}
!ENTRY org.eclipse.ui 4 0 2011-12-16 17:17:30.825
!MESSAGE Unhandled event loop exception
!STACK 0
org.eclipse.swt.SWTError: No more handles [Unknown Mozilla path (MOZILLA_FIVE_HOME not set)]
    at org.eclipse.swt.SWT.error(SWT.java:4109)
    at org.eclipse.swt.browser.Mozilla.initMozilla(Mozilla.java:1739)
    at org.eclipse.swt.browser.Mozilla.create(Mozilla.java:656)
    at org.eclipse.swt.browser.Browser.<init>(Browser.java:119)
    at com.aptana.git.ui.internal.actions.CommitDialog.createDiffArea(CommitDialog.java:237)
    at com.aptana.git.ui.internal.actions.CommitDialog.createDialogArea(CommitDialog.java:158)
    [...]
    at org.eclipse.equinox.launcher.Main.invokeFramework(Main.java:620)
    at org.eclipse.equinox.launcher.Main.basicRun(Main.java:575)
    at org.eclipse.equinox.launcher.Main.run(Main.java:1408)
    at org.eclipse.equinox.launcher.Main.main(Main.java:1384)
{{< /highlight >}}

Pour faire court, après avoir lu
[beaucoup](https://bugs.archlinux.org/task/5149)
[de](https://bugs.archlinux.org/task/27130)
[posts](https://github.com/eclipse-color-theme/eclipse-color-theme/issues/50)
[à ce sujet](https://bbs.archlinux.org/viewtopic.php?id=129982)
[sur](http://forums.gentoo.org/viewtopic-t-827838-view-previous.html?sid=546c5717e2167c45d9b02f9f20ab36f4)
[ce](http://stackoverflow.com/questions/1017945/problem-with-aptana-studio-xulrunner-8-1)
[problème](http://www.eclipse.org/swt/faq.php#gtk64), il semblait qu'il
suffisait de donner le chemin vers Xulrunner à Aptana.

Sur mon Arch Linux, c'était :

{{< highlight bash >}}
export MOZILLA_FIVE_HOME=/usr/lib/xulrunner-8.0
{{< /highlight >}}

En essayant de démarrer Aptana Studio, j'ai eu une nouvelle erreur. Elle disait
simplement :

{{< highlight text >}}
XPCOM error -2147467261
{{< /highlight >}}

La solution est qu'Aptana Studio ne peut pas fonctionner avec la version de
Xulrunner dans les dépôts Arch Linux car elle est trop récente.

Pour résoudre ce problème, j'ai dû installer xulrunner 1.9.2 depuis AUR :

{{< highlight bash >}}
yaourt -S xulrunner192
{{< /highlight >}}

Le PKGBUILD était cassé ce matin et se terminait par une erreur 404 lors de la
récupération des sources. Si vous avez le même problème, voici un PKGBUILD mis à
jour : [PKGBUILD mis à jour](https://gist.github.com/1486851).

Enfin, j'ai mis :

{{< highlight bash >}}
-Dorg.eclipse.swt.browser.XULRunnerPath=/usr/lib/xulrunner-1.9.2
{{< /highlight >}}

à la fin du fichier `AptanaStudio3.ini` dans le dossier d'Aptana Studio. Pour le
paquet dans les dépôts Arch Linux, ce fichier est
`/usr/share/aptana/AptanaStudio3.ini`.
